// Sennheiser microphone cap used on many of the older wireless "EW" series.
//Main "window" is controlled by the following viewport variable.
//This is usefull if don't want people turning off the mic.
viewport = False;

//Define outside height
height = 9;
//Define inside diameter
invar = 29.8;
//Define wall thickness
wall = 1.65;
//Define retaining internal ridge
ridgeht = 3.2;
ridgedp = .4;

//Define indents
ditdia = 1.7;
ditht = 3.0; //height of indent
ditoff = 0.7;//offset from top
//Define view hole
vhdia = 12; //diameter
vhlen = 19.8; //length

//Define LED indicator holes
ledsz = 2; //diameter of led hole
led1os = 9.0; //distance from center
led1ang = 155; //Rotation placement
led2os = 9.0; //distance from center
led2ang = 90; //Rotation placement

//End of Deffinitions

difference(){
difference(){
cylinder (h=height, r=invar/2 + wall, $fn=100);
translate([0,0,wall])
cylinder (h=height, r=invar/2,$fn=100);
translate([0,0,wall+.01])
color ("blue") 
cylinder (h=ridgeht, r=invar/2+ridgedp,$fn=100);
//Add view hole opening.
if (viewport) {
rotate(a=5, v=[0,0,1]){
translate([invar/2-vhdia/2-2,0,0])
translate([0,-vhlen/2+vhdia/2,-0.05])
hull() {
translate([0,vhlen-vhdia,0]) cylinder(h=wall+.1,r1=vhdia/2+1,r2=vhdia/2,$fn=80);
cylinder(h=wall+.1,r1=vhdia/2+1,r2=vhdia/2,$fn=80);
}//end of hull
}//end of rotate
}//end of if, can have else {place pinhole}
else {
rotate(a=5, v=[0,0,1]){
translate([invar/2-vhdia/2-2,-vhlen/2+vhdia/2,-0.05])
//translate([0,0,-0.05])
cylinder(h=wall+.1,r=2,$fn=80);
}//end of rotate
} //end if/else 

//add led indicator holes
for (o=[[led1os,led1ang],[led2os,led2ang]]) {
rotate(a=o[1], v=[0,0,1]){
translate([0,o[0],-0.05])
cylinder(h=wall+.1,r1=ledsz/2+1,r2=ledsz/2,$fn=80);
}//end of rotate
}//end for loop
}//end of difference for main shape.

//Define additional "decorations"
// Core idea below is to define a cylinder, offset it by the radius and then rotate it around the Z axis.

//Define the outside grip texture
//use for loop
for (n = [0,45,90,135,180,225,270,315]){
color ("green")
rotate(a=n, v=[0,0,1]){
translate ([invar/2+wall+2,0,-0.01])
cylinder(h = 7, r1=3, r2=2, $fn=60);
}//end rotate
}//end for loop

//Define the inside stop indents
//use for loop (120deg inc)
for (n = [5,65,185,295]){
color ("plum")
rotate(a=n, v=[0,0,1]){
translate ([invar/2-0.1,0,height-ditht-ditoff])
cylinder(h = ditht, r=ditdia/2, $fn=60);
}//end rotate
}//end for loop
}//end difference